//*****************************************************************************
// ""  1   "  " COM" 
//    ?" (http://clubpro.spb.ru/cominside/com0010.html)
//
//   
//
// -  
//   2000,  
//*****************************************************************************

#include "stdafx.h"     // 
#include "resource.h"   //  
#include "NeoIntrf.h"   // 
#include <tchar.h>      //   _T(str)


//   .     Win32
//    .     
//          .
//       -  
//  .
//   -    
//         ,  
// -        
//    ,     
//   -     .


//     .   
//" ",   ,   ,  
// " ".   -   ,  
//  .   " 
//"       .
extern "C" BOOL CALLBACK DialogProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);


//main  
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow){

  //    
	::DialogBox(hInstance,MAKEINTRESOURCE(IDD_DIALOG),NULL,DialogProc); 

	return 0;
}// main :)


//******************************************************************************
//  CoCreateInstance   .  
// -    

//    
HMODULE hServer = NULL;

//       
extern "C" int (__stdcall *pCoCreateEmulator)
             (const GUID& Clsid,const GUID& Iid, void ** ppv) = NULL;


//  CoCreateInstance    .   - 
//    CLSID-IID,     
//,  ,        
//      DllGetClassObject.    
//" "   ,  -    .
//    ,    0.   -1 
//   .
int CoGetClassObjectEmulator(const GUID& Clsid, //CLSID
                             const GUID& Iid,   //IID
                             void     ** ppv    //
                            ){

  //  DLL- -     
  //    -  -1
  if(hServer == NULL){

    hServer = ::LoadLibrary(_T("NeoSrv.DLL"));
    if(hServer == NULL) return -1;
                     }

  //       DllGetClassObject
  //     -  -1
  if(pCoCreateEmulator == NULL){

    pCoCreateEmulator = reinterpret_cast<
          int (__stdcall *)(const GUID&,const GUID&,void **)>(
              ::GetProcAddress(hServer,_T("DllGetClassObject")));

    if(pCoCreateEmulator == NULL) return 0;
                               }

  //     
  return (*pCoCreateEmulator)(Clsid,Iid,ppv);

}// CoGetClassObjectEmulator

//******************************************************************************


//******************************************************************************
//  (  COM)  

//     -      
NeoInterface * pBanzai = NULL;  //    Banzai
NeoInterface * pHello = NULL;   //    Hello 


//   .    -  
// ,       .  
//  wParam  lParam,  -     -
//   wParam
BOOL CALLBACK DialogProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam){

	switch (uMsg){
    //,     ,   
    //   .       
    //  .     -  
    //   ,     
    //""     .   
    //  ...
    case WM_INITDIALOG:
      if(pBanzai == NULL){
        ::CoGetClassObjectEmulator(CLSID_Banzai,
                                   IID_NeoInterface,
                                   (void **)&pBanzai
                                  );
                         }
      if(pHello == NULL){
        ::CoGetClassObjectEmulator(CLSID_Hello,
                                   IID_NeoInterface,
                                   (void **)&pHello
                                  );
                         }
      
      return FALSE;

    // ,  ,   
    // - .     
    // -  .       wParam
    //  ID ,     
	  case WM_COMMAND:
      if(LOWORD(wParam) == IDOK){
        //   OK (" ")    
        ::EndDialog(hwndDlg,0); 
	        return FALSE;
                                }

      else if(LOWORD(wParam) == IDC_BANZAISHOW){
        // Banzai::Show
        pBanzai->Show(hwndDlg);
                                               }

      else if(LOWORD(wParam) == IDC_BANZAISOUND){
        // Banzai::Sound
        pBanzai->Sound();
                                                }

      else if(LOWORD(wParam) == IDC_HELLOSHOW){
        // Hello::Show
        pHello->Show(hwndDlg);
                                              }

      else if(LOWORD(wParam) == IDC_HELLOSOUND){
        // Hello::Sound
        pHello->Sound();
                                               }

		    return FALSE;
	             }

	return FALSE;
}//  
